
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Java泛型解析(04)：约束和局限性 / 憋错料</title>

    <meta name="description" content="Java泛型解析(04)：约束和局限性 Java泛型解析(04):约束和局限性 前两节,认识和学习了泛型的限定以及通配符,初学者可能需要一些时间去体会到泛型程序设计的好处和力量,特别是想成为库程序员的同学就需要下去体会通配符的运用了,应用程序员则需要掌握怎么使用泛型,这里针对泛型的使用中的约束和局限性做一个介绍性的讲解. 不能用基本类型实例化类型参数 这个很好理解,实例化泛型类时泛型参数不能使用基本类型,如List&lt;int&gt;这是不合法的,要存储基本类型则可以利用基本类型的包装类如List&lt;Integer&gt; .L ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Java泛型解析(04)：约束和局限性</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p><strong>Java泛型解析(04)：约束和局限性</strong></p>

<p>前两节，认识和学习了泛型的限定以及通配符，初学者可能需要一些时间去体会到泛型程序设计的好处和力量，特别是想成为库程序员的同学就需要下去体会通配符的运用了，应用程序员则需要掌握怎么使用泛型，这里针对泛型的使用中的约束和局限性做一个介绍性的讲解。</p>
<p><strong>不能用基本类型实例化类型参数</strong></p>
<p>这个很好理解，实例化泛型类时泛型参数不能使用基本类型，如List&lt;int&gt;这是不合法的，要存储基本类型则可以利用基本类型的包装类如List&lt;Integer&gt; 、List&lt;Double&gt;等，下面补充一下八种基本类型对应的包装类，和默认初始&#20540;</p>
<p><em>[code01]：</p>
<p></em></p>
<pre>          byte                 Byte            0
          short                Short           0
          int                  Integer         0
          long                 Long            0L
          float                FLoat           0.0F
          double               Double          0.0D
          char                 Character       &#039;\u0000&#039;
          boolean              Boolean         false</pre>
<p><strong>不能实例化类型参数</strong></p>
<p>Java中创建对象使用new关键字，但是泛型的类型参数不能用于实例化对象，如：</p>
<p><em>[code02]</p>
<p></em></p>
<pre>     public Couple() {wife = new T(); husband = new T();} // 错误</pre>
<p>如果是在想要创建T对象，就必须使用Java反射来创建对象了，遗憾的是T.<strong>class</strong>在Java中也是不被支持使用的，所以一种弥补的方式，传入一个类型阐述为T的Class对象，如Class&lt;T&gt;</p>
<p><em>[code03]</p>
<p></em></p>
<pre>           public static &lt;T&gt; Couple&lt;T&gt; createInstance(Class&lt;T&gt; clazz) {
                    try {
                              return new Couple&lt;T&gt;(clazz.newInstance(), clazz.newInstance());
                   } catch (Exception e) {
                              return null ;
                   }
          }</pre>
<p>初学者对Java反射不熟悉不用着急，这里只要知道不能实例化类型参数即可，同理，不能实例化一个泛型数组，如</p>
<p><em>[code04]</p>
<p></em></p>
<pre>     public static &lt;T&gt; T[] maxTwo(T[] values) {T[] array = new T[2];} // 错误</pre>
<p>泛型构建数组是不合法的，因为这么构建在擦除之后构造的永远是<strong>new</strong>&nbsp;Object[2]，这不是我们所希望的结果。而且这样会导致一些运行时错误。为了更进一步说明隐患问题，来看看下面代码：</p>
<p>[code05]</p>
<pre>     public static &lt;T extends Comparable&lt;T&gt;&gt; T[] maxTwo(T[] array) {
          Object[] result = new Object[2];
          return (T[]) result; // Type safety: Unchecked cast from Object[] to T[]
     }</pre>
<p>这种方式会产生变异警告：Object[]转换为T[]是没有被检查的。我们来试一试这个调用：&nbsp;<em>maxTwo</em>(<strong>new</strong>&nbsp;String[]<br />
 {&nbsp;&quot;5&quot;,&nbsp;&quot;7&quot;&nbsp;,&nbsp;&quot;9&quot;&nbsp;});，运行后，发生了类型转换异常，因为方法在调用的时候将Object[]转换为String[]，失败的类型转化。怎么解决呢？同样这里可以使用Java发射来解决：</p>
<p>[code06]</p>
<pre>     public static &lt;T extends Comparable&lt;T&gt;&gt; T[] maxTwo(T[] array) {
          // Type safety: Unchecked cast from Object[] to T[]
          return (T[]) Array.newInstance(array.getClass().getComponentType(), 2) ;
     }</pre>
<p>不能声明参数化的数组</p>
<p>Couple&lt;Employee&gt;[] couple =&nbsp;<strong>new</strong>&nbsp;Couple&lt;Employee&gt;[5]&nbsp;;这种声明式不合法的，这里面有一个问题还是通过类型擦除机制来解释，类型擦除后couple的类型是Couple[]，考虑一下两种赋&#20540;方式：</p>
<p>1.couple[0] = &quot;wife&quot;时，编译器会报错，这个很明显的错误，couple每个元素都是Couple类型。</p>
<p>2.couple[0] = new Couple&lt;String&gt;()，类型擦除后这个可以通过数组检测，但仍然是错误的类型，因为couple在声明的时候定义的是Couple&lt;Employee&gt;，所以会出现问题。</p>
<p>如果要存放参数化类型对象的集合，可以考虑使用ArrayList&lt;Couple&lt;Employee&gt;&gt;进行声明，而且Java中建议优先使用集合，这样既安全又有效。</p>
<p><strong>类型参数不能进行类型查询</strong></p>
<p><strong>&nbsp; &nbsp; &nbsp;</strong>通常我们会使用<strong>if</strong>&nbsp;(arg1&nbsp;<strong>instanceof</strong>&nbsp;Couple)来判断arg1是否属于Couple类型，有些爱思考的程序员可能会想更具体地去判断arg1类型是属于Couple&lt;T&gt;，指定类型参数，如：</p>
<p><em>[code07]</p>
<p></em></p>
<pre>     if (arg1 instanceof Couple&lt;Employee&gt;){...} // 错误</pre>
<p>Java虚拟机中没有泛型概念，所有<strong>instanceof</strong>&nbsp;类型查询只查询原始类型，所以code07中的语法在Java中的不支持的。同理，在强制类型转换中也是不允许指定类型参数的，如：Couple&lt;Employee&gt;<br />
 couple = (Couple&lt;Employee&gt;)arg1;&nbsp;// 错误</p>
<p><strong>不能抛出、不能捕获泛型类实例</strong></p>
<p>在Java中，<strong>public</strong>&nbsp;<strong>class</strong>&nbsp;GenericException&nbsp;&lt;T&gt;&nbsp;<strong>extends</strong>&nbsp;Exception&nbsp;{...}这种泛型类扩展子Throwable是不合法的，不能通过编译器。</p>
<p>不能再catch子句中使用类型参数，如：</p>
<p><em>[code08]</p>
<p></em></p>
<pre>        public static &lt;T extends Throwable&gt; void doSomething(Class&lt;T&gt; t) {
             try {
                   // do something...
             } catch (T e) {
                   e.printStackTrace();
             }
          }  // 错误</pre>
<p>code08中的代码是不合法的，下面在异常声明中使用类型参数是合法的，例如：</p>
<p><em>[code09]</p>
<p></em></p>
<pre>          public static &lt;T extends Throwable&gt; void doSomething(T t) throws T {
                    try {
                              // do something...
                   } catch (Throwable e) {
                             e.printStackTrace();
                              throw t;
                   }
          }// 正确</pre>
<p>泛型类中的类型参数不能用于静态上下文中</p>
<p>怎么理解这个呢？看个例子就知道了，如一个泛型单例：</p>
<p>[code10]</p>
<pre>public class Singleton &lt;T&gt;{

           private static T instance;

           public static T getInstance(){ ..}
}</pre>
<p>上述代码，是无法通过编译器的，怎么解释这个呢？试想假设这个程序可以运行，声明一个Singleton&lt;String&gt;和一个Singleton&lt;Employee&gt;，类型擦除之后都是Singleton，但只包含了一个instance域，这个域不可能同时是String类型的又是Employee类型的，所以假设是不成立的，顺便回顾了一下学校里学的反证法~<br />
 ~</p>
<p><strong>类型擦除后引起的冲突</strong></p>
<p><strong>&nbsp; &nbsp; &nbsp;</strong>看一个泛型类：</p>
<p><em>[code11]</p>
<p></em></p>
<pre>     public class NameClash&lt;T&gt; {
           public boolean equals(T value) {
                    return false ;
          }
     }</pre>
<p>从这个类的定义中来看，存在两个equals方法，一个是自身定义的<strong>public</strong>&nbsp;<strong>boolean</strong>&nbsp;equals(T<br />
 value)&nbsp;{...}，一个是从Object继承的<strong>public</strong>&nbsp;<strong>boolean</strong>&nbsp;equals(Object<br />
 obj)&nbsp;{...}，但类型擦除以后，前者方法成为了<strong>public</strong>&nbsp;<strong>boolean</strong>&nbsp;equals(Object&nbsp;value)&nbsp;{...}，而在一个类中同时存在两个方法名和参数一样的方法是不可能的，所以这里引发的冲突是没法通过编译器的。可以通过重新命名方法进行修正。</p>
<p>擦除引起的冲突还体现在另一点上，再看一段错误的代码：</p>
<p><em>[code12]</p>
<p></em></p>
<pre>     class Calendar implements Comparable&lt;Calendar&gt; {...}
     class GregorianCalendar extends Calendar implements Comparable&lt;GregorianCalendar&gt; {...}</pre>
<p>上述代码是非法的，为什么？回顾一下类型擦除后，虚拟机会为<em>Calendar&nbsp;</em>类合成桥方法，实现了Comparable&lt;Calendar&gt;获得一个桥方法：</p>
<p>public&nbsp;<strong>int</strong>&nbsp;compareTo&nbsp;(Object<br />
 o)&nbsp;{<strong>return</strong>&nbsp;compareTo((Calendar)o);}</p>
<p>而实现了Comparable&lt;GregorianCalendar&nbsp;&gt;在类型擦除后，虚拟机为GregorianCalendar合成一个桥方法：</p>
<p>public&nbsp;<strong>int</strong>&nbsp;compareTo&nbsp;(Object<br />
 o)&nbsp;{<strong>return</strong>&nbsp;compareTo((GregorianCalendar&nbsp;)o);}</p>
<p>这样一来在GregorianCalendar类中存在两个一样的方法，这是不允许的。</p>
<p><a href="http://blog.csdn.net/ysjian_pingcx/article/details/40019183" rel="external nofollow noreferrer">Java泛型解析(01)：认识泛型</a></p>
<p><a href="http://blog.csdn.net/ysjian_pingcx/article/details/40039965" rel="external nofollow noreferrer">Java泛型解析(02)：通配符限定</a></p>
<p><a href="http://blog.csdn.net/ysjian_pingcx/article/details/40072247" rel="external nofollow noreferrer">Java泛型解析(03)：虚拟机执行泛型代码</a></p>
<p><a href="http://blog.csdn.net/ysjian_pingcx/article/details/40106363" rel="external nofollow noreferrer">Java泛型解析(04)：约束和局限性</a></p>
<p>=====【感谢亲阅读<a href="http://blog.csdn.net/ysjian_pingcx" rel="external nofollow noreferrer">平常心</a>的文章，亲若觉得此文有帮助，<strong>顶一顶</strong>呗<strong>，</strong>亲的支持将给我前进的动力】=====</p>
<p><img src="/Users/Ysjian/AppData/Local/Temp/enhtmlclip/2014-06-24_221032.jpg"></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-16 18:04:12 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/java/" title="java">java</a>, <a href="https://www.biecuoliao.com/tag/javase/" title="javase">javase</a>, <a href="https://www.biecuoliao.com/tag/%e9%9d%a2%e5%90%91%e5%af%b9%e8%b1%a1/" title="面向对象">面向对象</a>, <a href="https://www.biecuoliao.com/tag/java-%e6%b3%9b%e5%9e%8b/" title="java 泛型">java 泛型</a>, <a href="https://www.biecuoliao.com/tag/%e6%b3%9b%e5%9e%8b%e8%ae%be%e8%ae%a1/" title="泛型设计">泛型设计</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Java泛型解析(04)：约束和局限性的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0aGkpv4.html" rel="bookmark">Java泛型解析&lpar;03&rpar;：虚拟机执行泛型代码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java泛型解析(03):虚拟机执行泛型代码 Java虚拟机是不存在泛型类型对象的,所有的对象都属于普通类,甚至在泛型实现的早起版本中,可以将使用泛型的程序编译为在1.0虚拟机上能够运行的class文件,这个向后兼容性后期被抛弃了,所以后来如果用Sun公司的编译器编译的泛型代码,是不能运行在Java5.0之前的虚拟机的,这样就导致了一些实际生产的问题,如一些遗留代码如何跟新的系统进行衔接,要弄明白这个问题,需要先了解一下虚拟机是怎么执行泛型代码的. 虚拟机的一种机制:擦除类型参数,并将其替换成特			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0e6ojv3.html" rel="bookmark">Java泛型解析&lpar;02&rpar;：通配符限定</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java泛型解析(02):通配符限定 考虑一个这样的场景,计算数组中的最大元素. [code01] public class ArrayUtil { public static &lt;T&gt; T max(T[] array) { if (array == null || 0 == array.length) { return null ;} T max = array[0]; for (int i = 1; i &lt; array.length; i++) { if (max.compareTo(			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qbNKG4.html" rel="bookmark">Java泛型解析&lpar;01&rpar;：认识泛型</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				What Java从1.0版本到现在的8,中间Java5中发生了一个很重要的变化,那就是泛型机制的引入.Java5引入了泛型,主要还是为了满足在1999年指定的最早Java规范之一.经过了5年左右的时间,专家组定义了一套泛型规范,实现后通过测试投入到使用.所以说泛型是Java5以后才有的,欲知详情,继续往下看. Why      换个角度想,Java5引入泛型,必定是它能带来好处,否则牛气的Java专家工程师就要遭到吐槽了.我们来吐槽一下没有泛型的程序是怎么写的. [code01] ArrayL			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0eqBGb0.html" rel="bookmark">Java 泛型解析，太难了，认真读才能理解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java 泛型 关键字说明 ? 通配符类型 &lt;? extends T&gt; 表示类型的上界,表示参数化类型的可能是T 或是 T的子类 &lt;? super T&gt; 表示类型下界(Java Core中叫超类型限定),表示参数化类型是此类型的超类型(父类型),直至Object extends 示例 static class Food{} static class Fruit extends Food{} static class Apple extends Fruit{} static clas			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49GzZn0.html" rel="bookmark">Java泛型解析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. 概述    在引入范型之前,Java类型分为原始类型.复杂类型,其中复杂类型分为数组和类.引入范型后,一个复杂类型就可以在细分成更多的类型. 例如原先的类型List,现在在细分成List&lt;Object&gt;, List&lt;String&gt;等更多的类型.注意,现在List&lt;Object&gt;, List&lt;String&gt;是两种不同的类型,他们之间没有继承关系,即使String继承了Object.下面的代码是非法的: List&lt;String&gt; ls = ne			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/415e2J4.html" rel="bookmark">Java 泛型的约束与局限性</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java 泛型的约束与局限性 @author ixenos 不能用基本类型实例化类型参数 不能用类型参数代替基本类型:例如,没有Pair&lt;double&gt;,只有Pair&lt;Double&gt;,其原因是类型擦除.擦除之后,Pair类含有Object类型的域,而Object不能存储double值.这体现了Java语言中基本类型的独立状态. 运行时类型查询只适用于原始类型(raw type) 运行时:通常指在Classloader装载之后,JVM执行之时 类型查询:instanceof.getC			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0RKdQp3.html" rel="bookmark">Java8基础知识（十）泛型的约束与局限性</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				泛型的约束与局限性 由于泛型是通过类型擦除.强制类型转换和桥方法来实现的,所以存在某些局限(大多来自于擦除). 不能使用基本类型实例化类型参数 类型参数都是类,要用包装器将基本类型包装才可以作为类型参数(原因在于擦除类型后Object类不能存储基本类型的值).当包装器类不能接受类型参数替换时,可以使用独立的类和方法进行处理. 运行时类型查询只适用于原始类型 由于虚拟机中的对象都有特定的原始类型,所以类型查询只能查询原始类型. // 只能测试a是否为某种Pair类型 if (a instanceo			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0knqV7M.html" rel="bookmark">Java 集合系列 04 LinkedList详细介绍&lpar;源码解析&rpar;和使用示例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				java 集合系列目录: Java 集合系列 01 总体框架 Java 集合系列 02 Collection架构 Java 集合系列 03 ArrayList详细介绍(源码解析)和使用示例 Java 集合系列 04 LinkedList详细介绍(源码解析)和使用示例 概要  和学习ArrayList一样,接下来呢,我们先对LinkedList有个整体认识,然后再学习它的源码:最后再通过实例来学会使用LinkedList.内容包括:第1部分 LinkedList介绍第2部分 LinkedList数			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3rq7vX0.html" rel="bookmark">泛型（三）&mdash;&mdash;约束与局限性</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				因为java虚拟机没有泛型这一说法,所以在使用java泛型时需要考虑一些限制,大多数限制都是由类型擦除引起的. 1.不能用基本类型实例化类型参数 不能用类型参数代替基本类型.因此,没有Pair&lt;double&gt;,只有Pair&lt;Double&gt;.当然其原因是类型擦除.擦除之后,Pair类含有Object类型的域,而Object不能存储double值. 2.运行时类型查询只适用于原始类型 虚拟机中的对象总有一个特定的非泛型类型.因此,所有的类型查询只产生原始类型.例如: Pair&lt;S			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/9MBaYZ4.html" rel="bookmark" class="title">脚本应用之十六：  监控和消耗内存资源</a>
					<div>
						作用:监控或消耗内存资源, 指定需要消耗到的百分比 实现:通过在内存中写入一定大小的文件实现 演示: 直接回车,查看当前内存的百分比 输入欲消耗的内存百分比 代码专区: #/bin/bash   #  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/g417eY0.html" rel="bookmark" class="title">课堂训练</a>
					<div>
						1.对于可能的变更是否能制定应急计划? 可以制定 例如一款app的开发,在制作app之前会对app的功能性进行一个规划,想的比较全面就能很好应对变更. 2.员工是否能够有效地处理意料之外的工作请求?  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/D3OBOr0.html" rel="bookmark" class="title">c语言拾遗</a>
					<div>
						枚举常量: 枚举是一个常量整型值的列表的列表,例如 enum boolean{NO,YES}: 在没有显示说明的情况下,enum类型中第一个枚举名的值为0,第二个为1,以此类推. 如果只指定了部分枚举 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgLW9p0.html" rel="bookmark" class="title">【转】高斯消元模板 by kuangbin</a>
					<div>
						写的很好,注释很详细,很全面. 原blog地址:http://www.cnblogs.com/kuangbin/archive/2012/09/01/2667044.html #include&lt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49Z9oDM.html" rel="bookmark" class="title">设计3个按钮，当单击他们时分别使页面的背景色变成红、蓝和绿色。</a>
					<div>
						&lt;form name=&quot;myForm&quot;&gt; &lt;P&gt;&lt;INPUT type=&quot;button&quot; value=&quot;红&quot;  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZY92G0.html" rel="bookmark" class="title">js之引用类型</a>
					<div>
						一.摘要: &lt;javascript高级程序设计第三版&gt;一书中单独有一章对js的引用类型(Object.Array.RegExp.Function:基本包装类型:Boolean.Number ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QNVJeM.html" rel="bookmark" class="title">Same binary weight  &lpar;位运算&rpar;</a>
					<div>
						题目描述 The binary weight of a positive  integer is the number of 1's in its binary representation.for  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RGA273.html" rel="bookmark" class="title">python中使用heapq查看最大与最小的N个元素列表</a>
					<div>
						怎么从一个集合中获取最大或最小的N个元素列表? heapq模块有两个函数:nlargest() 和 nsmallest() 可以完美解决这个问题. In [39]: import heapq In [ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RGBY53.html" rel="bookmark" class="title">如何在latex 中插入EPS格式图片</a>
					<div>
						如何在latex 中插入EPS格式图片 第一步:生成.eps格式的图片 1.利用visio画图,另存为pdf格式的图片 利用Adobe Acrobat裁边,使图片大小合适 另存为.eps格式,如下图所 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4J8GpA0.html" rel="bookmark" class="title">cmd获取系统时间</a>
					<div>
						查看时间格式: echo %date% echo %time% 通过%date:~5,2%来组合得出当前日期,组合的效果为yyyymmdd,date命令得到的日期格式默认为yyyy-mm-dd,通过% ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lW7mZM.html" rel="bookmark" class="title">创业如此艰难，该何去何从？</a>
					<div>
						我相信在职创业人士都会有深刻的感受,无数次不断的问自己这句话. 同样,我也相信创业者们的第一个项目大多数都其代表性,在他们已知的世界里至少是这么认为的. 其实,只要能走出创业的这部分人都值得尊重和欣赏 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWLber0.html" rel="bookmark" class="title">安装完CentOS 7 后必做的七件事</a>
					<div>
						CentOS是最多人用来运行服务器的 Linux 版本,最新版本是 CentOS 7.当你兴趣勃勃地在一台主机或 VPS 上安装 CentOS 7 后,首要的工作肯定是加强它的安全性,以下列出的七件事 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mo5m2Q3.html" rel="bookmark" class="title">MST-prim</a>
					<div>
						MST(Minimum Spanning Tree,最小生成树)问题有两种通用的解法,Prim算法就是其中之一,它是从点的方面考虑构建一颗MST,大致思想是:设图G顶点集合为U,首先任意选择图G中的一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47w8l14.html" rel="bookmark" class="title">给大家分享一下------mysql的优化</a>
					<div>
						MySQL 优化专题拓展 --王耀宇   一.SQL优化 1.分析和定位策略 1.通过 show status 了解各种 SQL 的执行频率 2.定位执行效率低的 SQL 语句:①通过慢日志定位:②使 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41zkaqM.html" rel="bookmark" class="title">How to reset LCM module of BMW E60 2006&quest;</a>
					<div>
						The Light Control Module (LCM) is an important component of a vehicle because it controls all of the ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MV7dey0.html" rel="bookmark" class="title">【安卓自定义控件系列】安卓自定义控件之组合控件</a>
					<div>
						在安卓开发中,谷歌已经为我们提供了许多原生控件,基本上能够满足我们日常的开发需求,但是某些项目中原生控件可能达不到产品所要求的各式各样的酷炫效果或功能效果,这个时候我们只能自己自定义控件来满足项目需求 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mglw9L0.html" rel="bookmark" class="title">Linux&mdash;查看路由</a>
					<div>
						下面那些命令可以用来查看Linux主机的默认路由() A.route B.ifconfig C.ping D.netstat 分析: A.route命令用来显示目前本机路由表的内容,并且还可以针对路由 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35rQBR4.html" rel="bookmark" class="title">&lbrack;原&rsqb;零基础学习视频解码系列文章</a>
					<div>
						注:本系列文章的开发环境:Ubuntu 14.04+Eclipse4.3.2+CDT+FFmpeg2.3+SDL1.25 [原]零基础学习视频解码之安装ffmpeg [原]零基础学习视频解码之FFMp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bRx1p0.html" rel="bookmark" class="title">hdu 4876</a>
					<div>
						ZCC loves cards Time Limit: 4000/2000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)T ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWjAbb4.html" rel="bookmark" class="title">js实现小写转大写&comma;js实现数字转人民币</a>
					<div>
						&lt;!DOCTYPE HTML PUBLIC &quot;-//W3C//DTD HTML 4.0 Transitional//EN&quot;&gt; &lt;html&gt; &lt;head ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.034 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
